<html>
<head>
<title>Ogre::ScriptCompilerListener Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1ScriptCompilerListener.html">ScriptCompilerListener</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::ScriptCompilerListener Class Reference<div class="ingroups"><a class="el" href="group__General.html">General</a></div></div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::ScriptCompilerListener" -->
<p>This is a listener for the compiler.  
 <a href="classOgre_1_1ScriptCompilerListener.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgreScriptCompiler_8h_source.html">OgreScriptCompiler.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for Ogre::ScriptCompilerListener:</div>
<div class="dyncontent">
<div class="center"><img src="classOgre_1_1ScriptCompilerListener__inherit__graph.gif" border="0" usemap="#Ogre_1_1ScriptCompilerListener_inherit__map" alt="Inheritance graph"/></div>
<map name="Ogre_1_1ScriptCompilerListener_inherit__map" id="Ogre_1_1ScriptCompilerListener_inherit__map">
<area shape="rect" id="node3" href="classOgre_1_1ParticleScriptCompilerListener.html" title="This is the specific listener for the particle script compiler." alt="" coords="5,83,240,112"/></map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>

<p><a href="classOgre_1_1ScriptCompilerListener-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ScriptCompilerListener.html#a5ef77364e46586313bbe52bd80286fd7">ScriptCompilerListener</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ScriptCompilerListener.html#a2822f17d9ebae54955ceb220eb0421e0">~ScriptCompilerListener</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="group__General.html#ga9d11953f4cfbc8a1e225b910d881dc36">ConcreteNodeListPtr</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ScriptCompilerListener.html#a127cde78b54edd6826e7d7094404730a">importFile</a> (<a class="el" href="classOgre_1_1ScriptCompiler.html">ScriptCompiler</a> *compiler, const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the concrete node list from the given file.  <a href="#a127cde78b54edd6826e7d7094404730a"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ScriptCompilerListener.html#acacf340d804e9ed92d27ae2c45d675ea">preConversion</a> (<a class="el" href="classOgre_1_1ScriptCompiler.html">ScriptCompiler</a> *compiler, <a class="el" href="group__General.html#ga9d11953f4cfbc8a1e225b910d881dc36">ConcreteNodeListPtr</a> nodes)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Allows for responding to and overriding behavior before a CST is translated into an AST.  <a href="#acacf340d804e9ed92d27ae2c45d675ea"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ScriptCompilerListener.html#acaf9a789c4b3c37d4789442ebf1cb2b4">postConversion</a> (<a class="el" href="classOgre_1_1ScriptCompiler.html">ScriptCompiler</a> *compiler, const <a class="el" href="group__General.html#gad207f4cd0b8599200e52d366fe61f069">AbstractNodeListPtr</a> &amp;)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Allows vetoing of continued compilation after the entire AST conversion process finishes.  <a href="#acaf9a789c4b3c37d4789442ebf1cb2b4"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ScriptCompilerListener.html#ade5fc951cb11a6e2b428d29a9a1cbd2a">handleError</a> (<a class="el" href="classOgre_1_1ScriptCompiler.html">ScriptCompiler</a> *compiler, <a class="el" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> code, const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;file, int line, const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;msg)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Called when an error occurred.  <a href="#ade5fc951cb11a6e2b428d29a9a1cbd2a"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ScriptCompilerListener.html#a24910b11f8daa374e432336620ac9385">handleEvent</a> (<a class="el" href="classOgre_1_1ScriptCompiler.html">ScriptCompiler</a> *compiler, <a class="el" href="classOgre_1_1ScriptCompilerEvent.html">ScriptCompilerEvent</a> *evt, void *retval)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Called when an event occurs during translation, return true if handled.  <a href="#a24910b11f8daa374e432336620ac9385"></a><br/></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>This is a listener for the compiler. </p>
<p>The compiler can be customized with this listener. It lets you listen in on events occurring during compilation, hook them, and change the behavior. </p>

<p>Definition at line <a class="el" href="OgreScriptCompiler_8h_source.html#l00344">344</a> of file <a class="el" href="OgreScriptCompiler_8h_source.html">OgreScriptCompiler.h</a>.</p>
</div><hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a5ef77364e46586313bbe52bd80286fd7"></a><!-- doxytag: member="Ogre::ScriptCompilerListener::ScriptCompilerListener" ref="a5ef77364e46586313bbe52bd80286fd7" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1ScriptCompilerListener.html#a5ef77364e46586313bbe52bd80286fd7">Ogre::ScriptCompilerListener::ScriptCompilerListener</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="a2822f17d9ebae54955ceb220eb0421e0"></a><!-- doxytag: member="Ogre::ScriptCompilerListener::~ScriptCompilerListener" ref="a2822f17d9ebae54955ceb220eb0421e0" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1ScriptCompilerListener.html#a2822f17d9ebae54955ceb220eb0421e0">Ogre::ScriptCompilerListener::~ScriptCompilerListener</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreScriptCompiler_8h_source.html#l00348">348</a> of file <a class="el" href="OgreScriptCompiler_8h_source.html">OgreScriptCompiler.h</a>.</p>

</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="ade5fc951cb11a6e2b428d29a9a1cbd2a"></a><!-- doxytag: member="Ogre::ScriptCompilerListener::handleError" ref="ade5fc951cb11a6e2b428d29a9a1cbd2a" args="(ScriptCompiler *compiler, uint32 code, const String &amp;file, int line, const String &amp;msg)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1ScriptCompilerListener.html#ade5fc951cb11a6e2b428d29a9a1cbd2a">Ogre::ScriptCompilerListener::handleError</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1ScriptCompiler.html">ScriptCompiler</a> *&#160;</td>
          <td class="paramname"><em>compiler</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a>&#160;</td>
          <td class="paramname"><em>code</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>msg</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Called when an error occurred. </p>

</div>
</div>
<a class="anchor" id="a24910b11f8daa374e432336620ac9385"></a><!-- doxytag: member="Ogre::ScriptCompilerListener::handleEvent" ref="a24910b11f8daa374e432336620ac9385" args="(ScriptCompiler *compiler, ScriptCompilerEvent *evt, void *retval)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="classOgre_1_1ScriptCompilerListener.html#a24910b11f8daa374e432336620ac9385">Ogre::ScriptCompilerListener::handleEvent</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1ScriptCompiler.html">ScriptCompiler</a> *&#160;</td>
          <td class="paramname"><em>compiler</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1ScriptCompilerEvent.html">ScriptCompilerEvent</a> *&#160;</td>
          <td class="paramname"><em>evt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>retval</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Called when an event occurs during translation, return true if handled. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>This function is called from the translators when an event occurs that that can be responded to. Often this is overriding names, or it can be a request for custom resource creation. <ul>
<li>compiler A reference to the compiler </li>
<li>evt The event object holding information about the event to be processed </li>
<li>retval A possible return value from handlers </li>
</ul>
</dd></dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>True if the handler processed the event </dd></dl>

</div>
</div>
<a class="anchor" id="a127cde78b54edd6826e7d7094404730a"></a><!-- doxytag: member="Ogre::ScriptCompilerListener::importFile" ref="a127cde78b54edd6826e7d7094404730a" args="(ScriptCompiler *compiler, const String &amp;name)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="group__General.html#ga9d11953f4cfbc8a1e225b910d881dc36">ConcreteNodeListPtr</a> <a class="el" href="classOgre_1_1ScriptCompilerListener.html#a127cde78b54edd6826e7d7094404730a">Ogre::ScriptCompilerListener::importFile</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1ScriptCompiler.html">ScriptCompiler</a> *&#160;</td>
          <td class="paramname"><em>compiler</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>name</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns the concrete node list from the given file. </p>

</div>
</div>
<a class="anchor" id="acaf9a789c4b3c37d4789442ebf1cb2b4"></a><!-- doxytag: member="Ogre::ScriptCompilerListener::postConversion" ref="acaf9a789c4b3c37d4789442ebf1cb2b4" args="(ScriptCompiler *compiler, const AbstractNodeListPtr &amp;)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="classOgre_1_1ScriptCompilerListener.html#acaf9a789c4b3c37d4789442ebf1cb2b4">Ogre::ScriptCompilerListener::postConversion</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1ScriptCompiler.html">ScriptCompiler</a> *&#160;</td>
          <td class="paramname"><em>compiler</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="group__General.html#gad207f4cd0b8599200e52d366fe61f069">AbstractNodeListPtr</a> &amp;&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Allows vetoing of continued compilation after the entire AST conversion process finishes. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Once the script is turned completely into an AST, including import and override handling, this function allows a listener to exit the compilation process. </dd></dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>True continues compilation, false aborts </dd></dl>

</div>
</div>
<a class="anchor" id="acacf340d804e9ed92d27ae2c45d675ea"></a><!-- doxytag: member="Ogre::ScriptCompilerListener::preConversion" ref="acacf340d804e9ed92d27ae2c45d675ea" args="(ScriptCompiler *compiler, ConcreteNodeListPtr nodes)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1ScriptCompilerListener.html#acacf340d804e9ed92d27ae2c45d675ea">Ogre::ScriptCompilerListener::preConversion</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1ScriptCompiler.html">ScriptCompiler</a> *&#160;</td>
          <td class="paramname"><em>compiler</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__General.html#ga9d11953f4cfbc8a1e225b910d881dc36">ConcreteNodeListPtr</a>&#160;</td>
          <td class="paramname"><em>nodes</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Allows for responding to and overriding behavior before a CST is translated into an AST. </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreScriptCompiler_8h_source.html">OgreScriptCompiler.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:49:06
</p>
</body>
</html>
